## sfront 0.99

=== src/Makefile ===

#    Sfront, a SAOL to C translator    
#    This file: Makefile for Sfront
#
# Copyright (c) 2000-2006, Regents of the University of California
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
#
#  Redistributions of source code must retain the above copyright
#  notice, this list of conditions and the following disclaimer.
#
#  Redistributions in binary form must reproduce the above copyright
#  notice, this list of conditions and the following disclaimer in the
#  documentation and/or other materials provided with the distribution.
#
#  Neither the name of the University of California, Berkeley nor the
#  names of its contributors may be used to endorse or promote products
#  derived from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
#    Maintainer: John Lazzaro, lazzaro@cs.berkeley.edu


##
## The current version and release date.
##
##             0.99 08/30/11

##
## BINDIR specifies the directory for the object sfront file.
## The "make install" option uses BINDIR, and the examples
## supplied with sfront assume this directory is in your path.
## It defaults to the sfront/bin directory.

BINDIR = ../bin/

##
## Compiler optimization and debug options.
## 

CC = gcc 
OPT  = -O2 
DBUG =  -g
ECHECK = -ansi -Wall
MODEL = -m32

##
## Windows/UWIN users should replace this line with
##
## SFRONT = sfront.exe
##

SFRONT = sfront

##
## Machine/OS specific compiling options should be added
## to CFLAGS below.
##

CFLAGS = $(MODEL) $(OPT) $(DBUG) $(ECHECK)

## A few files gcc compiles very slowly on some platforms,
## so we add this flag to fix it.  Delete for other compilers.

SLOWSCHED = -fno-schedule-insns

##
## Machine/OS specific linking options should be added to
## LINKLIB below

LINKLIB = -lm

## Changes below this line shouldn't be needed -- if they are,
## add an appropriate definition above this line and refer to
## it below.

OBJS = parser.tab.o lex.o symbols.o globals.o treeupdate.o wtparse.o wtconst.o\
	corevars.o corecode.o special.o postparse.o readscore.o sfmain.o\
	writeorc.o blocktree.o writepre.o writeop.o writemain.o readmidi.o\
	mp4write.o tokens.o ascwrite.o mp4read.o collapse.o coreinline.o\
	audio.o control.o cmainpass.o csrclib.o asyslib.o csyslib.o \
	psyslib.o nsyslib.o parsehelp.o optconst.o optrate.o optrefer.o \
	optmain.o oclone.o stparse.o

## package maintainers need this to be first

all: $(SFRONT)

install: $(SFRONT)
	cp $(SFRONT) $(BINDIR)

clean:
	rm -f *.o $(SFRONT)

cleanall:
	rm -f *.o sfront $(BINDIR)sfront sfront.exe parser.tab.c parser.tab.h

csrclib.o:  csrclib.c tree.h parser.tab.h
	$(CC) $(CFLAGS) $(SLOWSCHED) -c -o csrclib.o csrclib.c

asyslib.o:  asyslib.c tree.h parser.tab.h
	$(CC) $(CFLAGS) $(SLOWSCHED) -c -o asyslib.o asyslib.c

csyslib.o:  csyslib.c tree.h parser.tab.h
	$(CC) $(CFLAGS) $(SLOWSCHED) -c -o csyslib.o csyslib.c

psyslib.o:  psyslib.c tree.h parser.tab.h
	$(CC) $(CFLAGS) $(SLOWSCHED) -c -o psyslib.o psyslib.c

nsyslib.o:  nsyslib.c tree.h parser.tab.h
	$(CC) $(CFLAGS) $(SLOWSCHED) -c -o nsyslib.o nsyslib.c

$(SFRONT):  $(OBJS) tree.h parser.tab.h
	$(CC) $(CFLAGS) $(OBJS) $(LINKLIB) -o $(SFRONT)

parser.tab.c:	parsehelp.c parser.y tree.h
	-bison -d parser.y	


##
## This section makes a distribution, in the directory
## $(BTYPE)dist which is at the same directory level as 
## sfront directory this Makefile resides in. To get
## this to work, you'll need to change the VERSION 
## string at the top of the file to be --VERSION--.
## You'll also need to change SFPLACE, SBPLACE and some "
## "cp" commands to copy documentation into the directories.
##
## If you're splitting off a new distribution, I'd suggest
## the following scheme: the original version number, followed
## by your initials, followed by your own version numbers. For
## example, Jane Q. Smith would split off version 0.5 into
## 0.5jqs0.1


## Name to prefix to binary distribution created by "make newdist"
##

BTYPE = gen

## New version number, date, and ID.
## Do "ls -lrt's" to check book freshness.
##

NEWVERSION = 0.99
NEWDATE = `date '+%m/%d/%y'`
NEWIDSTRING = $(NEWVERSION) $(NEWDATE)

## New versions of the sfront manual and book
##

SFPLACE = /Users/lazzaro/work/code/sfront/html/sfman/
SBPLACE = /Users/lazzaro/work/code/sfront/html/book/
CPPLACE = /Users/lazzaro/work/code/sfront/html/copyright/

newdist: 
	rm -rf ../../$(BTYPE)dist
	mkdir ../../$(BTYPE)dist
	mkdir ../../$(BTYPE)dist/sfront
	mkdir ../../$(BTYPE)dist/bin
	mkdir ../../$(BTYPE)dist/sfront/bin
	mkdir ../../$(BTYPE)dist/sfront/lib
	mkdir ../../$(BTYPE)dist/sfront/lib/Slib
	mkdir ../../$(BTYPE)dist/sfront/lib/reson
	mkdir ../../$(BTYPE)dist/sfront/src
	mkdir ../../$(BTYPE)dist/sfront/src/win
	mkdir ../../$(BTYPE)dist/sfront/src/lib
	mkdir ../../$(BTYPE)dist/sfront/src/lib/csrc
	mkdir ../../$(BTYPE)dist/sfront/src/lib/asys
	mkdir ../../$(BTYPE)dist/sfront/src/lib/csys
	mkdir ../../$(BTYPE)dist/sfront/src/lib/nsys
	mkdir ../../$(BTYPE)dist/sfront/src/lib/psys
	mkdir ../../$(BTYPE)dist/sfront/examples
	mkdir ../../$(BTYPE)dist/sfront/examples/rtime
	mkdir ../../$(BTYPE)dist/sfront/examples/rtime/au
	mkdir ../../$(BTYPE)dist/sfront/examples/rtime/network
	mkdir ../../$(BTYPE)dist/sfront/copyright
	mkdir ../../$(BTYPE)dist/sfront/sfman
	mkdir ../../$(BTYPE)dist/sfront/sfman/devel
	mkdir ../../$(BTYPE)dist/sfront/sfman/devel/adriver
	mkdir ../../$(BTYPE)dist/sfront/sfman/devel/intro
	mkdir ../../$(BTYPE)dist/sfront/sfman/devel/cdriver
	mkdir ../../$(BTYPE)dist/sfront/sfman/devel/cdriver/intro
	mkdir ../../$(BTYPE)dist/sfront/sfman/devel/cdriver/code
	mkdir ../../$(BTYPE)dist/sfront/sfman/devel/cdriver/data
	mkdir ../../$(BTYPE)dist/sfront/sfman/user
	mkdir ../../$(BTYPE)dist/sfront/sfman/user/cmdline
	mkdir ../../$(BTYPE)dist/sfront/sfman/user/cmdline/alsaseq
	mkdir ../../$(BTYPE)dist/sfront/sfman/user/install
	mkdir ../../$(BTYPE)dist/sfront/sfman/user/network
	mkdir ../../$(BTYPE)dist/sfront/sfman/user/ref
	mkdir ../../$(BTYPE)dist/sfront/sfman/user/rtime
	mkdir ../../$(BTYPE)dist/sfront/sfman/user/use
	mkdir ../../$(BTYPE)dist/sfront/book
	mkdir ../../$(BTYPE)dist/sfront/book/ack
	mkdir ../../$(BTYPE)dist/sfront/book/append
	mkdir ../../$(BTYPE)dist/sfront/book/append/cor1
	mkdir ../../$(BTYPE)dist/sfront/book/append/cor2/
	mkdir ../../$(BTYPE)dist/sfront/book/append/cor2/doc/
	mkdir ../../$(BTYPE)dist/sfront/book/append/corea
	mkdir ../../$(BTYPE)dist/sfront/book/append/coref
	mkdir ../../$(BTYPE)dist/sfront/book/append/lang
	mkdir ../../$(BTYPE)dist/sfront/book/append/notcov
	mkdir ../../$(BTYPE)dist/sfront/book/append/rules
	mkdir ../../$(BTYPE)dist/sfront/book/append/stnames
	mkdir ../../$(BTYPE)dist/sfront/book/append/wave
	mkdir ../../$(BTYPE)dist/sfront/book/bib
	mkdir ../../$(BTYPE)dist/sfront/book/control
	mkdir ../../$(BTYPE)dist/sfront/book/control/midi
	mkdir ../../$(BTYPE)dist/sfront/book/control/saolc
	mkdir ../../$(BTYPE)dist/sfront/book/control/sasl
	mkdir ../../$(BTYPE)dist/sfront/book/opcodes
	mkdir ../../$(BTYPE)dist/sfront/book/opcodes/filter
	mkdir ../../$(BTYPE)dist/sfront/book/opcodes/sgen
	mkdir ../../$(BTYPE)dist/sfront/book/opcodes/sproc
	mkdir ../../$(BTYPE)dist/sfront/book/opcodes/user
	mkdir ../../$(BTYPE)dist/sfront/book/opcodes/user/example
	mkdir ../../$(BTYPE)dist/sfront/book/opcodes/user/example/osine
	mkdir ../../$(BTYPE)dist/sfront/book/saol
	mkdir ../../$(BTYPE)dist/sfront/book/saol/bus
	mkdir ../../$(BTYPE)dist/sfront/book/saol/exstat
	mkdir ../../$(BTYPE)dist/sfront/book/saol/simple
	mkdir ../../$(BTYPE)dist/sfront/book/saol/vars
	mkdir ../../$(BTYPE)dist/sfront/book/saol/wave/
	mkdir ../../$(BTYPE)dist/sfront/book/saol/wave/examples
	mkdir ../../$(BTYPE)dist/sfront/book/saol/wave/examples/tsine
	mkdir ../../$(BTYPE)dist/sfront/book/simple
	mkdir ../../$(BTYPE)dist/sfront/book/simple/sine
	mkdir ../../$(BTYPE)dist/sfront/book/special
	mkdir ../../$(BTYPE)dist/sfront/book/special/debug
	mkdir ../../$(BTYPE)dist/sfront/book/special/slib
	mkdir ../../$(BTYPE)dist/sfront/book/special/au
	mkdir ../../$(BTYPE)dist/sfront/book/template
	mkdir ../../$(BTYPE)dist/sfront/book/tut
	mkdir ../../$(BTYPE)dist/sfront/book/tut/examples
	mkdir ../../$(BTYPE)dist/sfront/book/tut/examples/sine
	mkdir ../../$(BTYPE)dist/sfront/book/tut/examples/vcsine
	mkdir ../../$(BTYPE)dist/sfront/book/tut/examples/vsine
	cp ../lib/Slib/gmidi.hs  ../../$(BTYPE)dist/sfront/lib/Slib/
	cp ../lib/Slib/ssm.hs  ../../$(BTYPE)dist/sfront/lib/Slib/
	cp ../lib/Slib/std.hs  ../../$(BTYPE)dist/sfront/lib/Slib/
	cp ../lib/Slib/trig.hs  ../../$(BTYPE)dist/sfront/lib/Slib/
	cp ../lib/reson/README  ../../$(BTYPE)dist/sfront/lib/reson/
	cp ../lib/reson/abar.hs  ../../$(BTYPE)dist/sfront/lib/reson/
	cp ../lib/reson/macros.hs  ../../$(BTYPE)dist/sfront/lib/reson/
	cp ../lib/reson/marimba.hs  ../../$(BTYPE)dist/sfront/lib/reson/
	cp ../lib/reson/sreson.hs  ../../$(BTYPE)dist/sfront/lib/reson/
	cp ../lib/reson/string.hs  ../../$(BTYPE)dist/sfront/lib/reson/
	cp ../README.HTML ../../$(BTYPE)dist/sfront/README.HTML
	cp ../README.HTML ../../$(BTYPE)dist/sfront/index.html
	cp lex.c ../../$(BTYPE)dist/sfront/src/
	cp symbols.c ../../$(BTYPE)dist/sfront/src/
	cp globals.c ../../$(BTYPE)dist/sfront/src/
	cp treeupdate.c ../../$(BTYPE)dist/sfront/src/
	cp wtparse.c ../../$(BTYPE)dist/sfront/src/
	cp wtconst.c ../../$(BTYPE)dist/sfront/src/
	cp stparse.c ../../$(BTYPE)dist/sfront/src/
	cp corevars.c ../../$(BTYPE)dist/sfront/src/
	cp corecode.c ../../$(BTYPE)dist/sfront/src/
	cp special.c ../../$(BTYPE)dist/sfront/src/
	cp postparse.c ../../$(BTYPE)dist/sfront/src/
	cp readscore.c ../../$(BTYPE)dist/sfront/src/
	cp sfmain.c ../../$(BTYPE)dist/sfront/src/
	cp writeorc.c ../../$(BTYPE)dist/sfront/src/
	cp blocktree.c ../../$(BTYPE)dist/sfront/src/
	cp oclone.c ../../$(BTYPE)dist/sfront/src/
	cp writepre.c ../../$(BTYPE)dist/sfront/src/
	cp writeop.c ../../$(BTYPE)dist/sfront/src/
	cp writemain.c ../../$(BTYPE)dist/sfront/src/
	cp readmidi.c ../../$(BTYPE)dist/sfront/src/
	cp mp4write.c ../../$(BTYPE)dist/sfront/src/
	cp tokens.c ../../$(BTYPE)dist/sfront/src/
	cp ascwrite.c ../../$(BTYPE)dist/sfront/src/
	cp mp4read.c ../../$(BTYPE)dist/sfront/src/
	cp collapse.c ../../$(BTYPE)dist/sfront/src/
	cp optconst.c ../../$(BTYPE)dist/sfront/src/
	cp optrate.c ../../$(BTYPE)dist/sfront/src/
	cp optrefer.c ../../$(BTYPE)dist/sfront/src/
	cp optmain.c ../../$(BTYPE)dist/sfront/src/
	cp coreinline.c ../../$(BTYPE)dist/sfront/src/
	cp audio.c ../../$(BTYPE)dist/sfront/src/
	cp control.c ../../$(BTYPE)dist/sfront/src/
	cp cmainpass.c ../../$(BTYPE)dist/sfront/src/
	(cd lib; make cfiles; make clean)
	cp csrclib.c ../../$(BTYPE)dist/sfront/src/
	cp csyslib.c ../../$(BTYPE)dist/sfront/src/
	cp asyslib.c ../../$(BTYPE)dist/sfront/src/
	cp psyslib.c ../../$(BTYPE)dist/sfront/src/
	cp nsyslib.c ../../$(BTYPE)dist/sfront/src/
	cp csrclib.h ../../$(BTYPE)dist/sfront/src/
	cp csyslib.h ../../$(BTYPE)dist/sfront/src/
	cp asyslib.h ../../$(BTYPE)dist/sfront/src/
	cp psyslib.h ../../$(BTYPE)dist/sfront/src/
	cp nsyslib.h ../../$(BTYPE)dist/sfront/src/
	touch parser.tab.c
	cp parser.y ../../$(BTYPE)dist/sfront/src/

=== examples/min/Makefile ===


#    Sfront, a SAOL to C translator    
#    This file: Makefile for an sfront example
#
# Copyright (c) 2000-2006, Regents of the University of California
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
#
#  Redistributions of source code must retain the above copyright
#  notice, this list of conditions and the following disclaimer.
#
#  Redistributions in binary form must reproduce the above copyright
#  notice, this list of conditions and the following disclaimer in the
#  documentation and/or other materials provided with the distribution.
#
#  Neither the name of the University of California, Berkeley nor the
#  names of its contributors may be used to endorse or promote products
#  derived from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
#    Maintainer: John Lazzaro, lazzaro@cs.berkeley.edu

FILENAME = min

SAOLFILE = $(FILENAME).saol
SASLFILE = $(FILENAME).sasl
MP4FILE  = $(FILENAME).mp4

INFILE = 
OUTFILE = output.wav

##
## Compiler optimization and debug options. Mac OS X users 
## should replace "gcc" with "cc".
## 

CC = gcc
OPT = -O3
CFLAGS = $(OPT)

SFRONT = sfront
PLAYER = play
CMP = cmp

OUTMODE = -aout $(OUTFILE)
INMODE = 

## for INFILE/OUTFILE selections that need libraries

IOLINK = 

## for INFILE/OUTFILE std selection:  > foo < bar

REDIRECT = 

##
## makes a WAV file
##
 
$(OUTFILE): $(SAOLFILE) $(SASLFILE)
	$(SFRONT) $(OUTMODE) $(INMODE) -orc $(SAOLFILE) -sco $(SASLFILE)
	$(CC) $(CFLAGS) sa.c -lm $(IOLINK) -o sa
	./sa $(REDIRECT)

## tests bitstream creation code, by creating an MP4 file, decoding
## it, and comparing audio out with audio created by original ASCII
## files. doesn't work with stdin/stdout.

mp4test	: $(OUTFILE)
	rm -rf $(MP4FILE) sa.c
	mv $(OUTFILE) safe
	$(SFRONT)  -orc $(SAOLFILE) -sco $(SASLFILE) -bitout $(MP4FILE)
	$(SFRONT) $(OUTMODE) $(INMODE) -bit $(MP4FILE)
	$(CC) $(CFLAGS) sa.c -lm $(IOLINK) -o sa
	./sa $(REDIRECT)
	$(CMP) $(OUTFILE) safe

## tests a new sfront against an old one. assume safe is the audio
## created by old sfront. 

compare	: $(OUTFILE)
	$(CMP) $(OUTFILE) safe

safe	: $(OUTFILE)
	cp $(OUTFILE) safe

## for performance testing
##

timing	: 
	/usr/bin/time -p ./sa $(REDIRECT)

##
##
##

## only works on HPUX, for WAV files

play  : $(OUTFILE)
	$(PLAYER) $(OUTFILE)

clean: 
	rm -rf sa.c sa audio a*.wav $(MP4FILE) $(OUTFILE) *.info *~ safe

=== src/lib/Makefile ===

##    Sfront, a SAOL to C translator    
##    This file: Makefile to make sfront + new libraries
##
## Copyright (c) 1999-2006, Regents of the University of California
## All rights reserved.
##
## Redistribution and use in source and binary forms, with or without
## modification, are permitted provided that the following conditions are
## met:
##
##  Redistributions of source code must retain the above copyright
##  notice, this list of conditions and the following disclaimer.
##
##  Redistributions in binary form must reproduce the above copyright
##  notice, this list of conditions and the following disclaimer in the
##  documentation and/or other materials provided with the distribution.
##
##  Neither the name of the University of California, Berkeley nor the
##  names of its contributors may be used to endorse or promote products
##  derived from this software without specific prior written permission.
##
## THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
## "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
## LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
## A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
## OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
## SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
## LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
## DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
## THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
## (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
## OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
##
##    Maintainer: John Lazzaro, lazzaro@cs.berkeley.edu


##
## The current version and release date.
##
##             --IDSTRING--

##
## Compiler optimization and debug options. Mac OS X users 
## should replace "gcc" with "cc".
##

CC = gcc
OPT  = -O2 
DBUG = -g
MODEL = -m32

##
## Machine/OS specific compiling options should be added
## to CFLAGS below.
##

CFLAGS = $(OPT) $(DBUG) $(MODEL)

##
## 

LIBMAKER = libmaker

OBJS = libmaker.o 

##
##  Networking support is not enabled in this sfront distribution.
##  See the sfront/src/NETWORK.HTML file for full instructions on how
##  to enable networking support.  In this file, comment out the
##  blank NSYS definition below, and uncommment the NSYS definition
##  one the two lines that follow (be sure to uncomment both lines).
##

NSYS = 

##  NSYS = net_sfront net_include net_globals net_siplib \
##         net_rtplib net_rtcplib net_jsend net_jrecv net_crypto


PSYS =  pa_hosthdr pa_porthdr pa_tracehdr pa_lib pa_unix_oss \
	pa_win_wmme pa_dshdr pa_dswrap pa_dsound

CSRC =  runtime runtimef callback robust preamble runspt \
        tsync psync tgen 

ASYS  = aif hpux raw wav dsound linux freebsd std vcdat null irix \
	portaudio coreaudio audiounit wiretap

CSYS = ascii gliss linmidi freebsdmidi win32 alsamidi alsaseq fstr \
       coremidi aucontrol

all: $(LIBMAKER)
	./libmaker -csrc $(CSRC)
	./libmaker -asys $(ASYS)
	./libmaker -csys $(CSYS)
	./libmaker -nsys $(NSYS)
	./libmaker -psys $(PSYS)
	(cd .. ; make; cd lib)

cfiles: $(LIBMAKER)
	./libmaker -csrc $(CSRC)
	./libmaker -asys $(ASYS)
	./libmaker -csys $(CSYS)
	./libmaker -nsys $(NSYS)
	./libmaker -psys $(PSYS)

$(LIBMAKER):  $(OBJS) libmaker.h
	$(CC) $(CFLAGS) $(OBJS) -o $(LIBMAKER)

do_csrc: $(LIBMAKER)
	./libmaker -csrc $(CSRC)
	(cd .. ; make; cd lib)

do_asys: $(LIBMAKER)
	./libmaker -asys $(ASYS)
	(cd .. ; make; cd lib)

do_csys: $(LIBMAKER)
	./libmaker -csys $(CSYS)
	(cd .. ; make; cd lib)

do_nsys: $(LIBMAKER)
	./libmaker -nsys $(NSYS)
	(cd .. ; make; cd lib)

do_psys: $(LIBMAKER)
	./libmaker -psys $(PSYS)
	(cd .. ; make; cd lib)

clean:
	rm -f *.o $(LIBMAKER)

=== examples/rtime/aatest/Makefile ===

#    Sfront, a SAOL to C translator    
#    This file: Makefile for an sfront example
#
# License also applies to SAOL and SASL files. MIDI file is public 
# domain, courtesy of the http://www.mutopiaproject.org project
#
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
#
#  Redistributions of source code must retain the above copyright
#  notice, this list of conditions and the following disclaimer.
#
#  Redistributions in binary form must reproduce the above copyright
#  notice, this list of conditions and the following disclaimer in the
#  documentation and/or other materials provided with the distribution.
#
#  Neither the name of the University of California, Berkeley nor the
#  names of its contributors may be used to endorse or promote products
#  derived from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
#    Maintainer: John Lazzaro, lazzaro@cs.berkeley.edu


FILENAME = aatest

SAOLFILE = $(FILENAME).saol
SASLFILE = $(FILENAME).sasl
MIDIFILE = $(FILENAME).mid
MP4FILE  = $(FILENAME).mp4

INFILE = 

##
## By default, this is set up to work for Linux. To run one
## of the other UNIX platform tests, change OUTFILE to be
## the correct driver name, and see "IOLINK" comment below.
##
## OUTFILE = irix     ## For SGI IRIX
## OUTFILE = hpux     ## For HPUX
## OUTFILE = freebsd  ## For FreeBSD
## 
## See the README file in this directory for Microsoft Windows
## and Macintosh OS X compilation instructions.
##

OUTFILE = linux

CC = gcc
OPT = -O3
CFLAGS = $(OPT)
SFRONT = sfront 
PLAYER = play
CMP = cmp

OUTMODE = -aout $(OUTFILE)
INMODE = 

## IOLINK adds linking options for soundcard drivers. The
## default linux option uses no linking options.
##
## 
## IOLINK = -laudio   ## For SGI IRIX 
## IOLINK = -lAlib    ## For HPUX
## IOLINK =           ## FreeBSD needs no linking options.
##

IOLINK = 

## for INFILE/OUTFILE std selection:  > foo < bar

REDIRECT = 

##
## makes a raw 16-bit signed integer audio file
##
 
$(OUTFILE): $(SAOLFILE) $(MIDIFILE)
	$(SFRONT) $(OUTMODE) $(INMODE) -orc $(SAOLFILE) -sco $(SASLFILE) -midi $(MIDIFILE)
	$(CC) $(CFLAGS) sa.c -lm $(IOLINK) -o sa
	./sa $(REDIRECT)

## tests bitstream creation code, by creating an MP4 file, decoding
## it, and comparing audio out with audio created by original ASCII
## files. doesn't work with stdin/stdout.

mp4test	: $(OUTFILE)
	rm -rf $(MP4FILE) sa.c
	mv $(OUTFILE) safe
	$(SFRONT)  -orc $(SAOLFILE) -midi $(MIDIFILE) -sco $(SASLFILE) -bitout $(MP4FILE)
	$(SFRONT) $(OUTMODE) $(INMODE) -bit $(MP4FILE)
	$(CC) $(CFLAGS) sa.c -lm $(IOLINK) -o sa
	./sa $(REDIRECT)
	$(CMP) $(OUTFILE) safe

## tests a new sfront against an old one. assume safe is the audio
## created by old sfront. 

compare	: $(OUTFILE)
	$(CMP) $(OUTFILE) safe

safe	: $(OUTFILE)
	cp $(OUTFILE) safe

## for performance testing
##

timing	: 
	/usr/bin/time -p ./sa 

##
##
##

play  : $(OUTFILE)
	$(PLAYER) $(OUTFILE)

clean: 
	rm -rf sa.c sa audio a*.wav $(MP4FILE) $(OUTFILE) *.info *~ safe

=== examples/rtime/ascii/Makefile ===


#    Sfront, a SAOL to C translator    
#    This file: Makefile for an sfront example
#
# Copyright (c) 2000-2006, Regents of the University of California
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
#
#  Redistributions of source code must retain the above copyright
#  notice, this list of conditions and the following disclaimer.
#
#  Redistributions in binary form must reproduce the above copyright
#  notice, this list of conditions and the following disclaimer in the
#  documentation and/or other materials provided with the distribution.
#
#  Neither the name of the University of California, Berkeley nor the
#  names of its contributors may be used to endorse or promote products
#  derived from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
#    Maintainer: John Lazzaro, lazzaro@cs.berkeley.edu


FILENAME = ascii

SAOLFILE = $(FILENAME).saol
SASLFILE = $(FILENAME).sasl

##
## By default, this is set up to work for Linux. To run one
## of the other UNIX platform tests, change OUTFILE to be
## the correct driver name, and see "IOLINK" comment below.
##
## OUTFILE = irix     ## For SGI IRIX
## OUTFILE = hpux     ## For HPUX
## OUTFILE = freebsd  ## For FreeBSD
## 
## See the README file for Macintosh OS X compilation instructions.
##

OUTFILE = linux

CC = gcc
OPT = -O3
CFLAGS = $(OPT)
SFRONT = sfront 

OUTMODE = -aout $(OUTFILE)
INMODE = 
CNMODE = -cin ascii


## for INFILE/OUTFILE selections that need libraries
## IOLINK adds linking options for soundcard drivers. The
## default linux option uses no linking options.
##
## 
## IOLINK = -laudio   ## For SGI IRIX 
## IOLINK = -lAlib    ## For HPUX
## IOLINK =           ## FreeBSD needs no linking options.
##

IOLINK = 

##
## makes a raw 16-bit signed integer audio file
##
 
$(OUTFILE): $(SAOLFILE) 
	$(SFRONT) $(OUTMODE) $(CNMODE) -orc $(SAOLFILE) -sco $(SASLFILE)
	$(CC) $(CFLAGS) sa.c -lm $(IOLINK) -o sa
	./sa 

clean: 
	rm -rf sa.c sa audio a*.wav $(MP4FILE) $(OUTFILE) *.info *~ safe

=== examples/rtime/linain/Makefile ===


#    Sfront, a SAOL to C translator    
#    This file: Makefile for an sfront example
#
# Copyright (c) 2000-2006, Regents of the University of California
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
#
#  Redistributions of source code must retain the above copyright
#  notice, this list of conditions and the following disclaimer.
#
#  Redistributions in binary form must reproduce the above copyright
#  notice, this list of conditions and the following disclaimer in the
#  documentation and/or other materials provided with the distribution.
#
#  Neither the name of the University of California, Berkeley nor the
#  names of its contributors may be used to endorse or promote products
#  derived from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
#    Maintainer: John Lazzaro, lazzaro@cs.berkeley.edu


FILENAME = linain

SAOLFILE = $(FILENAME).saol
SASLFILE = $(FILENAME).sasl
MP4FILE  = $(FILENAME).mp4

INFILE = 
OUTFILE = all

CC = gcc
OPT = -O3
CFLAGS = $(OPT)

## increase latency if sound output clicks too much

SFRONT = sfront -latency 0.002

##
## By default, this is set up to work for Linux. To run one
## of the other UNIX platform tests, change ADRIVER to be
## the correct driver name, and see "IOLINK" comment below.
##
## ADRIVER = irix     ## For SGI IRIX
## ADRIVER = hpux     ## For HPUX
## ADRIVER = freebsd  ## For FreeBSD
## 
## See the README file in this directory for Microsoft Windows
## and Macintosh OS X compilation instructions.
##
##

ADRIVER = linux

OUTMODE = -aout $(ADRIVER)
INMODE  = -ain  $(ADRIVER)

## IOLINK adds linking options for soundcard drivers. The
## default linux option uses no linking options.
##
## 
## IOLINK = -laudio   ## For SGI IRIX 
## IOLINK = -lAlib    ## For HPUX
## IOLINK =           ## FreeBSD needs no linking options.
##

IOLINK = 

## for INFILE/OUTFILE std selection:  > foo < bar

REDIRECT = 

##
## makes a raw 16-bit signed integer audio file
##
 
$(OUTFILE): $(SAOLFILE) 
	$(SFRONT) $(OUTMODE) $(INMODE) -orc $(SAOLFILE) -sco $(SASLFILE)
	$(CC) $(CFLAGS) sa.c -lm $(IOLINK) -o sa
	./sa $(REDIRECT)

## tests bitstream creation code, by creating an MP4 file, decoding
## it, and comparing audio out with audio created by original ASCII
## files. doesn't work with stdin/stdout.

mp4test	: $(OUTFILE)
	rm -rf $(MP4FILE) sa.c
	mv $(OUTFILE) safe
	$(SFRONT) -symtab -orc $(SAOLFILE) -bitout $(MP4FILE)
	$(SFRONT) $(OUTMODE) $(INMODE) -bit $(MP4FILE)
	$(CC) $(CFLAGS) sa.c -lm $(IOLINK) -o sa
	./sa $(REDIRECT)
	cmp $(OUTFILE) safe

## tests a new sfront against an old one. assume safe is the audio
## created by old sfront. 

compare	: $(OUTFILE)
	cmp $(OUTFILE) safe

safe	: $(OUTFILE)
	cp $(OUTFILE) safe

## for performance testing
##

timing	: 
	./sa $(REDIRECT)

##
##
##

## only works on HPUX, for WAV files

play  : $(OUTFILE)
	splayer $(OUTFILE)

clean: 
	rm -rf sa.c sa audio a*.wav $(MP4FILE) $(OUTFILE) *.info *~ safe

=== examples/rtime/linbuzz/Makefile ===


#    Sfront, a SAOL to C translator    
#    This file: Makefile for an sfront example
#
# Copyright (c) 2000-2006, Regents of the University of California
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
#
#  Redistributions of source code must retain the above copyright
#  notice, this list of conditions and the following disclaimer.
#
#  Redistributions in binary form must reproduce the above copyright
#  notice, this list of conditions and the following disclaimer in the
#  documentation and/or other materials provided with the distribution.
#
#  Neither the name of the University of California, Berkeley nor the
#  names of its contributors may be used to endorse or promote products
#  derived from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
#    Maintainer: John Lazzaro, lazzaro@cs.berkeley.edu


FILENAME = linbuzz

SAOLFILE = $(FILENAME).saol
SASLFILE = $(FILENAME).sasl
MP4FILE  = $(FILENAME).mp4

INFILE = 
OUTFILE = all


CC = gcc
OPT = -O3
CFLAGS = $(OPT)

# a relative path just so it works
# out of the box in this directory.
# Use an absolute path, or set the
# SFRONT_INCLUDE_PATH environment
# variable to the absolute path,
# so that the -Is flag is not needed.

LIBPATH = ../../../lib
LIBMODE = -gcc -cpp -Is $(LIBPATH)

SFRONT = sfront 


## try 0.004 if clicks happen

OUTMODE = -latency 0.002 -aout linux
INMODE = 
CNMODE = -cin linmidi

## for INFILE/OUTFILE selections that need libraries

IOLINK = 

## for INFILE/OUTFILE std selection:  > foo < bar

REDIRECT = 

##
## makes a raw 16-bit signed integer audio file
##
 
$(OUTFILE): $(SAOLFILE) 
	$(SFRONT) $(LIBMODE) $(OUTMODE) $(CNMODE) -orc $(SAOLFILE) -sco $(SASLFILE)
	$(CC) $(CFLAGS) sa.c -lm $(IOLINK) -o sa
	./sa $(REDIRECT)

## tests bitstream creation code, by creating an MP4 file, decoding
## it, and comparing audio out with audio created by original ASCII
## files. doesn't work with stdin/stdout.

mp4test	: $(OUTFILE)
	rm -rf $(MP4FILE) sa.c
	mv $(OUTFILE) safe
	$(SFRONT) $(LIBMODE) -symtab -orc $(SAOLFILE) -bitout $(MP4FILE)
	$(SFRONT) $(LIBMODE) $(OUTMODE) $(INMODE) -bit $(MP4FILE)
	$(CC) $(CFLAGS) sa.c -lm $(IOLINK) -o sa
	./sa $(REDIRECT)
	cmp $(OUTFILE) safe

## tests a new sfront against an old one. assume safe is the audio
## created by old sfront. 

compare	: $(OUTFILE)
	cmp $(OUTFILE) safe

safe	: $(OUTFILE)
	cp $(OUTFILE) safe

## for performance testing
##

timing	: 
	./sa $(REDIRECT)

##
##
##

## only works on HPUX, for WAV files

play  : $(OUTFILE)
	splayer $(OUTFILE)

clean: 
	rm -rf sa.c sa audio a*.wav $(MP4FILE) $(OUTFILE) *.info *~ safe

=== examples/rtime/linvoc/Makefile ===


#    Sfront, a SAOL to C translator    
#    This file: Makefile for an sfront example
#
# Copyright (c) 2000-2006, Regents of the University of California
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
#
#  Redistributions of source code must retain the above copyright
#  notice, this list of conditions and the following disclaimer.
#
#  Redistributions in binary form must reproduce the above copyright
#  notice, this list of conditions and the following disclaimer in the
#  documentation and/or other materials provided with the distribution.
#
#  Neither the name of the University of California, Berkeley nor the
#  names of its contributors may be used to endorse or promote products
#  derived from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
#    Maintainer: John Lazzaro, lazzaro@cs.berkeley.edu


FILENAME = linvoc

SAOLFILE = $(FILENAME).saol
SASLFILE = $(FILENAME).sasl
MP4FILE  = $(FILENAME).mp4

INFILE = 
OUTFILE = all

CC = gcc
OPT = -O3
CFLAGS = $(OPT)
SFRONT = sfront 

OUTMODE = -latency 0.002 -aout linux
INMODE = -ain linux
CNMODE = -cin linmidi

## for INFILE/OUTFILE selections that need libraries

IOLINK = 

## for INFILE/OUTFILE std selection:  > foo < bar

REDIRECT = 

##
## makes a raw 16-bit signed integer audio file
##
 
$(OUTFILE): $(SAOLFILE) 
	$(SFRONT) $(OUTMODE) $(INMODE) $(CNMODE) -orc $(SAOLFILE) -sco $(SASLFILE)
	$(CC) $(CFLAGS) sa.c -lm $(IOLINK) -o sa
	./sa $(REDIRECT)

## tests bitstream creation code, by creating an MP4 file, decoding
## it, and comparing audio out with audio created by original ASCII
## files. doesn't work with stdin/stdout.

mp4test	: $(OUTFILE)
	rm -rf $(MP4FILE) sa.c
	mv $(OUTFILE) safe
	$(SFRONT) -symtab -orc $(SAOLFILE) -bitout $(MP4FILE)
	$(SFRONT) $(OUTMODE) $(INMODE) -bit $(MP4FILE)
	$(CC) $(CFLAGS) sa.c -lm $(IOLINK) -o sa
	./sa $(REDIRECT)
	cmp $(OUTFILE) safe

## tests a new sfront against an old one. assume safe is the audio
## created by old sfront. 

compare	: $(OUTFILE)
	cmp $(OUTFILE) safe

safe	: $(OUTFILE)
	cp $(OUTFILE) safe

## for performance testing
##

timing	: 
	./sa $(REDIRECT)

##
##
##

## only works on HPUX, for WAV files

play  : $(OUTFILE)
	splayer $(OUTFILE)

clean: 
	rm -rf sa.c sa audio a*.wav $(MP4FILE) $(OUTFILE) *.info *~ safe

=== examples/rtime/au/hiss/Makefile ===

#    Sfront, a SAOL to C translator
#    This file: Creates an Effect or MusicEffect AudioUnit
#
# License below also covers SAOL and SASL programs in this directory.
#
# Copyright (c) 2000-2006, Regents of the University of California
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
#
#  Redistributions of source code must retain the above copyright
#  notice, this list of conditions and the following disclaimer.
#
#  Redistributions in binary form must reproduce the above copyright
#  notice, this list of conditions and the following disclaimer in the
#  documentation and/or other materials provided with the distribution.
#
#  Neither the name of the University of California, Berkeley nor the
#  names of its contributors may be used to endorse or promote products
#  derived from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
#    Maintainer: John Lazzaro, lazzaro@cs.berkeley.edu


## To use this Makefile:
##
## "make":  Creates a AU component from your SAOL file in this directory
## "make install": Installs your plug-in and launches an AU host for testing
## "make clean": Removes all files created by "make" from this directory
## "make remove": Un-installs your plugin, and does a "make clean"
##

## 
## Use the variables below to configure how this Makefile works.
## See Part V/4 of the MP4SA book for more details. Note that
## YES and NO are case-sensitive -- yes and no won't work properly.
##

## To compile the AU binary using gcc's debug mode, set to YES

GCC_DEBUG = NO

## To compile SAOL file with the wiretap debug facility, set to YES
## Wiretap mode creates clicks in audio output; do not use for production code

WIRETAP_DEBUG = NO

## Change to YES to compile against the Snow Leopard SDK (and above)
## The default NO creates a component that only runs on your native OS/CPU

SNOW_LEOPARD = NO

## The project name: must match SAOL file name (without .saol suffix)
## Project names must not use white-space characters (space, tab, etc)
## This Makefile only works for Effects and MusicEffects projects.

PROJECT_NAME = hiss

## The 4-character codes for AU component subtype and manufacturer

COMPONENT_SUBTYPE_CODE = Hiss
COMPONENT_MANUFACTURER_CODE = ucBe

## Name and Manufacturer strings shown in the AU Host user interface

USER_INTERFACE_NAME =  "Inline Noise Generator"
USER_INTERFACE_MANUFACTURER = "John Lazzaro, UCB EECS"

## Manufacturer URL (expressed using Java-Classpath-string syntax)

MANUFACTURER_URL = edu.berkeley.eecs

## NO creates an Effect AudioUnit; YES creates a MusicEffect
## See Part V/4 of the MP4SA book for more details.

MUSICEFFECT = NO

## Mac OS X AU library directory in which to install your plug-in

COMPONENT_LIBRARY = ~/Library/Audio/Plug-Ins/Components

## The Terminal command launched after installing your plug-in

AUHOST_LAUNCH =	open $(PROJECT_NAME).band

##
## The lines below do the actual work of the Makefile.
## You will normally not need to edit the lines below.
##

# conditionals to parse user configuration YES/NO strings

ifeq ($(GCC_DEBUG), YES)
	DEBUG = -g
else
	DEBUG =
endif

ifeq ($(WIRETAP_DEBUG), YES)
	OUTMODE = -aout audiounit_debug
else
	OUTMODE = -aout audiounit
endif

ifeq ($(SNOW_LEOPARD), YES)
	SNOW_LEOPARD_FLAGS = -isysroot /Developer/SDKs/MacOSX10.6.sdk
	R_SNOW_LEOPARD_FLAGS = -isysroot /Developer/SDKs/MacOSX10.6.sdk
else
	SNOW_LEOPARD_FLAGS = 
	R_SNOW_LEOPARD_FLAGS = 
endif

ifeq ($(MUSICEFFECT), YES)
	CNMODE = -cin aucontrolm
else
	CNMODE = -cin aucontrol
endif

ifdef COMPONENT_SUBTYPE_CODE
	COMP_SUBTYPE = -au_component_subtype $(COMPONENT_SUBTYPE_CODE)
else
	COMP_SUBTYPE =
endif

ifdef COMPONENT_MANUFACTURER_CODE
	COMP_MANU = -au_component_manu $(COMPONENT_MANUFACTURER_CODE)
else
	COMP_MANU =
endif

ifdef USER_INTERFACE_NAME
	UI_NAME =  -au_ui_name $(USER_INTERFACE_NAME)
else
	UI_NAME = 
endif

ifdef USER_INTERFACE_MANUFACTURER
	UI_MANU = -au_ui_manu $(USER_INTERFACE_MANUFACTURER)
else
	UI_MANU =
endif

ifdef MANUFACTURER_URL
	MANU_URL =  -au_manu_url $(MANUFACTURER_URL)
else
	MANU_URL = 
endif

# sfront command-line definitions

SFRONT = sfront
BINARYFILE = ./$(PROJECT_NAME).component/Contents/MacOS/$(PROJECT_NAME)
DRIVERS = -ain audiounit $(CNMODE) $(OUTMODE)
FS_NAME =  -au_filesystem_name $(PROJECT_NAME)
AU_ID =  $(UI_NAME) $(COMP_SUBTYPE) $(COMP_MANU) $(UI_MANU) $(MANU_URL)

# gcc command-line definitions

CC = gcc 
OPT = -O3
MODEL = -m32
CFLAGS = $(MODEL) $(OPT) $(DEBUG) $(SNOW_LEOPARD_FLAGS)
IOLINK = -framework AudioUnit -framework AudioToolbox -framework CoreAudio -framework CoreServices -bundle

# rezedit definitions

RSRC = ./$(PROJECT_NAME).component/Contents/Resources/$(PROJECT_NAME).rsrc
RINCLUDES = -I /System/Library/Frameworks/CoreServices.framework/Frameworks/CarbonCore.framework/Versions/A/Headers
RFLAGS = -useDF -d SystemSevenOrLater=1 -script Roman -d "ppc_$ppc" -d i386_YES -arch i386  

# rules

$(BINARYFILE): $(PROJECT_NAME).saol 
	-rm -rf $(PROJECT_NAME).component
	mkdir $(PROJECT_NAME).component{,/Contents,/Contents/{Resources,MacOS}}
	$(SFRONT) $(DRIVERS) $(AU_ID) -orc $(PROJECT_NAME).saol 
	$(CC) $(CFLAGS) sa.c -lm $(IOLINK) -o $(BINARYFILE)
	Rez $(RFLAGS) $(R_SNOW_LEOPARD_FLAGS) $(RINCLUDES) -o $(RSRC) ./$(PROJECT_NAME).r
	-rm -rf $(PROJECT_NAME).r
	mv -f Info.Plist $(PROJECT_NAME).component/Contents/
	printf "BNDL????" > $(PROJECT_NAME).component/Contents/PkgInfo

install: $(BINARYFILE)
	-rm -rf $(COMPONENT_LIBRARY)/$(PROJECT_NAME).component
	cp -r $(PROJECT_NAME).component $(COMPONENT_LIBRARY)/
	$(AUHOST_LAUNCH)

clean: 
	-rm -rf sa.c *~ safe Info.Plist $(PROJECT_NAME).r $(PROJECT_NAME).component

remove: clean
	-rm -rf $(COMPONENT_LIBRARY)/$(PROJECT_NAME).component

=== examples/rtime/au/lpf/Makefile ===

#    Sfront, a SAOL to C translator
#    This file: Creates an Effect AudioUnit with a custom UI view
#
# License below also covers SAOL and SASL programs in this directory.
# Files in the view sub-directory may be covered by a different license.
#
# Copyright (c) 2000-2006, Regents of the University of California
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
#
#  Redistributions of source code must retain the above copyright
#  notice, this list of conditions and the following disclaimer.
#
#  Redistributions in binary form must reproduce the above copyright
#  notice, this list of conditions and the following disclaimer in the
#  documentation and/or other materials provided with the distribution.
#
#  Neither the name of the University of California, Berkeley nor the
#  names of its contributors may be used to endorse or promote products
#  derived from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
#    Maintainer: John Lazzaro, lazzaro@cs.berkeley.edu


## To use this Makefile:
##
## "make":  Creates a AU component from your SAOL file in this directory
## "make install": Installs your plug-in and launches an AU host for testing
## "make clean": Removes all files created by "make" from this directory
## "make remove": Un-installs your plugin, and does a "make clean"
##

## 
## Use the variables below to configure how this Makefile works.
## See Part V/4 of the MP4SA book for more details. Note that
## YES and NO are case-sensitive -- yes and no won't work properly.
##

## To compile the AU binary using gcc's debug mode, set to YES

GCC_DEBUG = NO

## To compile SAOL file with the wiretap debug facility, set to YES
## Wiretap mode creates clicks in audio output; do not use for production code

WIRETAP_DEBUG = NO

## Change to YES to compile against the Snow Leopard SDK (and above)
## The default NO creates a component that only runs on your native OS/CPU

SNOW_LEOPARD = NO

## The project name: must match SAOL file name (without .saol suffix)
## Project names must not use white-space characters (space, tab, etc)
## This Makefile only works for Effects and MusicEffects projects.

PROJECT_NAME = lpf

## The 4-character codes for AU component subtype and manufacturer

COMPONENT_SUBTYPE_CODE = lpfa
COMPONENT_MANUFACTURER_CODE = ucBe

## Name and Manufacturer strings shown in the AU Host user interface

USER_INTERFACE_NAME =  "Lo-Pass Filter"
USER_INTERFACE_MANUFACTURER = "John Lazzaro, UCB EECS"

## Manufacturer URL (expressed using Java-Classpath-string syntax)

MANUFACTURER_URL = edu.berkeley.eecs

## NO creates an Effect AudioUnit; YES creates a MusicEffect
## See Part V/4 of the MP4SA book for more details.

MUSICEFFECT = NO

## To use a Cocoa custom view, set to YES

COCOA_VIEW = YES

## The name of the custom view bundle (without the .bundle extension).
## The name string must not have white-space characters.  A directory
## of name $(COCOA_VIEW_BUNDLE_NAME) must exist in the directory that
## contains this Makefile, and the directory $(COCOA_VIEW_BUNDLE_NAME)
## must contain the view bundle $(COCOA_VIEW_BUNDLE_NAME).bundle

COCOA_VIEW_BUNDLE_NAME = CocoaFilterView

## The name of the class in the view bundle that implements the
## AUCocoaUIBase protocol.

COCOA_VIEW_BASECLASS = UCBLopassFilter_ViewFactory

## Mac OS X AU library directory in which to install your plug-in

COMPONENT_LIBRARY = ~/Library/Audio/Plug-Ins/Components

## The Terminal command launched after installing your plug-in

AUHOST_LAUNCH =	open $(PROJECT_NAME).band

##
## The lines below do the actual work of the Makefile.
## You will normally not need to edit the lines below.
##

# conditionals to parse user configuration YES/NO strings

ifeq ($(GCC_DEBUG), YES)
	DEBUG = -g
else
	DEBUG =
endif

ifeq ($(WIRETAP_DEBUG), YES)
	OUTMODE = -aout audiounit_debug
else
	OUTMODE = -aout audiounit
endif

ifeq ($(SNOW_LEOPARD), YES)
	SNOW_LEOPARD_FLAGS = -isysroot /Developer/SDKs/MacOSX10.6.sdk
	R_SNOW_LEOPARD_FLAGS = -isysroot /Developer/SDKs/MacOSX10.6.sdk
else
	SNOW_LEOPARD_FLAGS = 
	R_SNOW_LEOPARD_FLAGS = 
endif

ifeq ($(MUSICEFFECT), YES)
	CNMODE = -cin aucontrolm
else
	CNMODE = -cin aucontrol
endif


ifeq ($(COCOA_VIEW), YES)
	COPYVIEW = cp -r $(COCOA_VIEW_BUNDLE_NAME)/$(COCOA_VIEW_BUNDLE_NAME).bundle $(PROJECT_NAME).component/Contents/Resources/
else
	COPYVIEW = 
endif


ifdef COMPONENT_SUBTYPE_CODE
	COMP_SUBTYPE = -au_component_subtype $(COMPONENT_SUBTYPE_CODE)
else
	COMP_SUBTYPE =
endif

ifdef COMPONENT_MANUFACTURER_CODE
	COMP_MANU = -au_component_manu $(COMPONENT_MANUFACTURER_CODE)
else
	COMP_MANU =
endif

ifdef USER_INTERFACE_NAME
	UI_NAME =  -au_ui_name $(USER_INTERFACE_NAME)
else
	UI_NAME = 
endif

ifdef USER_INTERFACE_MANUFACTURER
	UI_MANU = -au_ui_manu $(USER_INTERFACE_MANUFACTURER)
else
	UI_MANU =
endif

ifdef MANUFACTURER_URL
	MANU_URL =  -au_manu_url $(MANUFACTURER_URL)
else
	MANU_URL = 
endif

ifeq ($(COCOA_VIEW), YES)

ifdef COCOA_VIEW_BUNDLE_NAME
	VNAME = -au_view_bundlename $(COCOA_VIEW_BUNDLE_NAME)
else
	VNAME = 
endif

ifdef COCOA_VIEW_BASECLASS
	VCLASS = -au_view_baseclass $(COCOA_VIEW_BASECLASS)
else
	VCLASS = 
endif
else
	VNAME = 
	VCLASS = 
endif

# sfront command-line definitions

SFRONT = sfront
BINARYFILE = ./$(PROJECT_NAME).component/Contents/MacOS/$(PROJECT_NAME)
DRIVERS = -ain audiounit $(CNMODE) $(OUTMODE)
FS_NAME =  -au_filesystem_name $(PROJECT_NAME)
AU_ID = $(UI_NAME) $(COMP_SUBTYPE) $(COMP_MANU) $(UI_MANU) $(VNAME) $(VCLASS)\
	$(MANU_URL)

# gcc command-line definitions

CC = gcc
OPT = -O3
MODEL = -m32
CFLAGS = $(MODEL) $(OPT) $(DEBUG) $(SNOW_LEOPARD_FLAGS)
IOLINK = -framework AudioUnit -framework AudioToolbox -framework CoreAudio -framework CoreServices -bundle

# rezedit definitions

RSRC = ./$(PROJECT_NAME).component/Contents/Resources/$(PROJECT_NAME).rsrc
RINCLUDES = -I /System/Library/Frameworks/CoreServices.framework/Frameworks/CarbonCore.framework/Versions/A/Headers
RFLAGS = -useDF -d SystemSevenOrLater=1 -script Roman -d "ppc_$ppc" -d i386_YES -arch i386  

# view-directory Makefile variable-passing

VIEWMAKEVARS =	GCC_DEBUG='$(GCC_DEBUG)' SNOW_LEOPARD='$(SNOW_LEOPARD)' \
	       	COCOA_VIEW_BUNDLE_NAME='$(COCOA_VIEW_BUNDLE_NAME)' \
		OPT='$(OPT)' MODEL='$(MODEL)' CC='$(CC)'

# rules

$(BINARYFILE): $(PROJECT_NAME).saol
	(pushd $(COCOA_VIEW_BUNDLE_NAME); make $(VIEWMAKEVARS); popd)
	-rm -rf $(PROJECT_NAME).component
	mkdir $(PROJECT_NAME).component{,/Contents,/Contents/{Resources,MacOS}}
	$(SFRONT) $(DRIVERS) $(AU_ID) -orc $(PROJECT_NAME).saol 
	$(CC) $(CFLAGS) sa.c -lm $(IOLINK) -o $(BINARYFILE)
	Rez $(RFLAGS) $(R_SNOW_LEOPARD_FLAGS) $(RINCLUDES) -o $(RSRC) ./$(PROJECT_NAME).r
	-rm -rf $(PROJECT_NAME).r
	mv -f Info.Plist $(PROJECT_NAME).component/Contents/
	printf "BNDL????" > $(PROJECT_NAME).component/Contents/PkgInfo
	$(COPYVIEW)

install: $(BINARYFILE)
	(pushd $(COCOA_VIEW_BUNDLE_NAME); make $(VIEWMAKEVARS) install; popd)
	-rm -rf $(COMPONENT_LIBRARY)/$(PROJECT_NAME).component
	cp -r $(PROJECT_NAME).component $(COMPONENT_LIBRARY)/
	$(AUHOST_LAUNCH)

clean: 
	(pushd $(COCOA_VIEW_BUNDLE_NAME); make $(VIEWMAKEVARS) clean; popd)
	-rm -rf sa.c *~ safe Info.Plist $(PROJECT_NAME).r $(PROJECT_NAME).component

remove: clean
	(pushd $(COCOA_VIEW_BUNDLE_NAME); make $(VIEWMAKEVARS) remove; popd)
	-rm -rf $(COMPONENT_LIBRARY)/$(PROJECT_NAME).component

=== examples/rtime/au/sin/Makefile ===

#    Sfront, a SAOL to C translator    
#    This file: Creates a MusicDevice AudioUnit
#
# License below also covers SAOL and SASL programs in this directory.
#
# Copyright (c) 2000-2006, Regents of the University of California
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
#
#  Redistributions of source code must retain the above copyright
#  notice, this list of conditions and the following disclaimer.
#
#  Redistributions in binary form must reproduce the above copyright
#  notice, this list of conditions and the following disclaimer in the
#  documentation and/or other materials provided with the distribution.
#
#  Neither the name of the University of California, Berkeley nor the
#  names of its contributors may be used to endorse or promote products
#  derived from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
#    Maintainer: John Lazzaro, lazzaro@cs.berkeley.edu


## To use this Makefile:
##
## "make":  Creates a AU component from your SAOL file in this directory
## "make install": Installs your plug-in and launches an AU host for testing
## "make clean": Removes all files created by "make" from this directory
## "make remove": Un-installs your plugin, and does a "make clean"
##

## 
## Use the variables below to configure how this Makefile works.
## See Part V/4 of the MP4SA book for more details. Note that
## YES and NO are case-sensitive -- yes and no won't work properly.
##

## To compile the AU binary using gcc's debug mode, set to YES

GCC_DEBUG = NO

## To compile SAOL file with the wiretap debug facility, set to YES
## Wiretap mode creates clicks in audio output; do not use for production code

WIRETAP_DEBUG = NO

## Change to YES to compile against the Snow Leopard SDK (and above)
## The default NO creates a component that only runs on your native OS/CPU

SNOW_LEOPARD = NO

## The project name: must match SAOL file name (without .saol suffix)
## Project names must not use white-space characters (space, tab, etc)
## This Makefile only works for MusicDevice projects.

PROJECT_NAME = sin

## The 4-character codes for AU component subtype and manufacturer

COMPONENT_SUBTYPE_CODE = snsn
COMPONENT_MANUFACTURER_CODE = ucBe

## Name and Manufacturer strings shown in the AU Host user interface

USER_INTERFACE_NAME = "Sinewave Synth"
USER_INTERFACE_MANUFACTURER = "John Lazzaro, UCB EECS"

## Manufacturer URL (expressed using Java-Classpath-string syntax)

MANUFACTURER_URL = edu.berkeley.eecs

## Mac OS X AU library directory in which to install your plug-in

COMPONENT_LIBRARY = ~/Library/Audio/Plug-Ins/Components

## The Terminal command launched after installing your plug-in

AUHOST_LAUNCH =	open $(PROJECT_NAME).band

##
## The lines below do the actual work of the Makefile.
## You will normally not need to edit the lines below.
##

# conditionals to parse user configuration YES/NO strings

ifeq ($(GCC_DEBUG), YES)
	DEBUG = -g
else
	DEBUG =
endif

ifeq ($(WIRETAP_DEBUG), YES)
	OUTMODE = -aout audiounit_debug
else
	OUTMODE = -aout audiounit
endif

ifeq ($(SNOW_LEOPARD), YES)
	SNOW_LEOPARD_FLAGS = -isysroot /Developer/SDKs/MacOSX10.6.sdk
	R_SNOW_LEOPARD_FLAGS = -isysroot /Developer/SDKs/MacOSX10.6.sdk
else
	SNOW_LEOPARD_FLAGS = 
	R_SNOW_LEOPARD_FLAGS = 
endif

ifdef COMPONENT_SUBTYPE_CODE
	COMP_SUBTYPE = -au_component_subtype $(COMPONENT_SUBTYPE_CODE)
else
	COMP_SUBTYPE =
endif

ifdef COMPONENT_MANUFACTURER_CODE
	COMP_MANU = -au_component_manu $(COMPONENT_MANUFACTURER_CODE)
else
	COMP_MANU =
endif

ifdef USER_INTERFACE_NAME
	UI_NAME =  -au_ui_name $(USER_INTERFACE_NAME)
else
	UI_NAME = 
endif

ifdef USER_INTERFACE_MANUFACTURER
	UI_MANU = -au_ui_manu $(USER_INTERFACE_MANUFACTURER)
else
	UI_MANU =
endif

ifdef MANUFACTURER_URL
	MANU_URL =  -au_manu_url $(MANUFACTURER_URL)
else
	MANU_URL = 
endif

# sfront command-line definitions

SFRONT = sfront
BINARYFILE = ./$(PROJECT_NAME).component/Contents/MacOS/$(PROJECT_NAME)
DRIVERS = -cin aucontrolm $(OUTMODE)
FS_NAME =  -au_filesystem_name $(PROJECT_NAME)
AU_ID =  $(UI_NAME) $(COMP_SUBTYPE) $(COMP_MANU) $(UI_MANU) $(MANU_URL)

# gcc command-line definitions

CC = gcc 
OPT = -O3
MODEL = -m32
CFLAGS = $(MODEL) $(OPT) $(DEBUG) $(SNOW_LEOPARD_FLAGS)
IOLINK = -framework AudioUnit -framework AudioToolbox -framework CoreAudio -framework CoreServices -bundle

# rezedit definitions

RSRC = ./$(PROJECT_NAME).component/Contents/Resources/$(PROJECT_NAME).rsrc
RINCLUDES = -I /System/Library/Frameworks/CoreServices.framework/Frameworks/CarbonCore.framework/Versions/A/Headers
RFLAGS = -useDF -d SystemSevenOrLater=1 -script Roman -d "ppc_$ppc" -d i386_YES -arch i386  

# rules

$(BINARYFILE): $(PROJECT_NAME).saol 
	-rm -rf $(PROJECT_NAME).component
	mkdir $(PROJECT_NAME).component{,/Contents,/Contents/{Resources,MacOS}}
	$(SFRONT) $(DRIVERS) $(AU_ID) -orc $(PROJECT_NAME).saol 
	$(CC) $(CFLAGS) sa.c -lm $(IOLINK) -o $(BINARYFILE)
	Rez $(RFLAGS) $(R_SNOW_LEOPARD_FLAGS) $(RINCLUDES) -o $(RSRC) ./$(PROJECT_NAME).r
	-rm -rf $(PROJECT_NAME).r
	mv -f Info.Plist $(PROJECT_NAME).component/Contents/
	printf "BNDL????" > $(PROJECT_NAME).component/Contents/PkgInfo

install: $(BINARYFILE)
	-rm -rf $(COMPONENT_LIBRARY)/$(PROJECT_NAME).component
	cp -r $(PROJECT_NAME).component $(COMPONENT_LIBRARY)/
	$(AUHOST_LAUNCH)

clean: 
	-rm -rf sa.c *~ safe Info.Plist $(PROJECT_NAME).r $(PROJECT_NAME).component

remove: clean
	-rm -rf $(COMPONENT_LIBRARY)/$(PROJECT_NAME).component

=== examples/rtime/network/mirror/Makefile ===

#    Sfront, a SAOL to C translator    
#    This file: Makefile for an sfront example
#
# Copyright (c) 2000-2006, Regents of the University of California
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
#
#  Redistributions of source code must retain the above copyright
#  notice, this list of conditions and the following disclaimer.
#
#  Redistributions in binary form must reproduce the above copyright
#  notice, this list of conditions and the following disclaimer in the
#  documentation and/or other materials provided with the distribution.
#
#  Neither the name of the University of California, Berkeley nor the
#  names of its contributors may be used to endorse or promote products
#  derived from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
#    Maintainer: John Lazzaro, lazzaro@cs.berkeley.edu



##
## sets network session to special mirror session

NETWORK = -session mirror

##
## Audio output driver, as shown below configured for linux.
## To run one of the other UNIX platform tests, change AOUT to be
## the correct driver name, and see "IOLINK" comment below.
##
## AOUT = -aout irix     ## For SGI IRIX
## AOUT = -aout hpux     ## For HPUX
## AOUT = -aout freebsd  ## For FreeBSD
## 
## See the README file for Macintosh OS X compilation instructions.
##

AOUT = -aout linux 


##
## control driver, as shown below configured for ascii keyboard. 
## if you have a MIDI keyboard, the linmidi driver (OSS) is known to work,
## other MIDI jack control drivers are untested but should work too.

CIN = -cin ascii


##
## for AOUT and CIN selections that need libraries linked with sa.c
## Linux needs no linking options. For other platforms:
## 
## IOLINK = -laudio   ## For SGI IRIX 
## IOLINK = -lAlib    ## For HPUX
## IOLINK =           ## FreeBSD needs no linking options.
##

IOLINK = 


##
## end of audio/network/control configuration
##

FILENAME = mirror

SAOLFILE = $(FILENAME).saol
SASLFILE = $(FILENAME).sasl

CC = gcc
OPT = -O3
CFLAGS = $(OPT)
SFRONT = sfront

$(FILENAME): $(SAOLFILE) 
	$(SFRONT) $(NETWORK) $(AOUT) $(CIN) -orc $(SAOLFILE) -sco $(SASLFILE)
	$(CC) $(CFLAGS) sa.c -lm $(IOLINK) -o sa
	./sa 

clean: 
	rm -rf sa.c sa audio a*.wav $(MP4FILE) $(OUTFILE) *.info *~ safe

=== debian/changelog ===
sfront (0.99-5) unstable; urgency=medium

  * Add debian/salsa-ci.yml.
  * Honor dpkg-buildflags.
  * Add a superficial test.
  * Do not trim Debian changelog.
  * Add Vcs-Git and Vcs-Browser fields.
  * Update Standards-Version.

 -- Santiago Vila <sanvila@debian.org>  Sun, 12 Jan 2025 18:10:00 +0100

sfront (0.99-4) unstable; urgency=medium

  * debian/rules: Create parser.tab.c (and parser.tab.h) before anything else.
    This is a workaround for a Makefile bug where some files requiring
    parser.tab.h to be built lack a proper dependency.

 -- Santiago Vila <sanvila@debian.org>  Sat, 08 Jun 2024 11:00:00 +0200

sfront (0.99-3) unstable; urgency=medium

  * Update Homepage.
  * Trim trailing whitespace.
  * Raise debhelper compat level from 9 to 13.
  * Update standards version to 4.6.1.

 -- Santiago Vila <sanvila@debian.org>  Tue, 13 Dec 2022 23:55:00 +0100

sfront (0.99-2) unstable; urgency=medium

  * Switch to dh.
  * Standards-Version: 3.9.8 (no special changes for this).

 -- Santiago Vila <sanvila@debian.org>  Tue, 10 Jan 2017 18:36:26 +0100

sfront (0.99-1) unstable; urgency=medium

  * New upstream release.
  * Fixed typo in README.Debian.
  * Switch to debhelper version 9.
  * Added hardened build flags, using dpkg-buildflags.
  * Do not reference BSD in common-licenses anymore. Put the full
    copyright notice and license in the copyright file.

 -- Santiago Vila <sanvila@debian.org>  Sun, 18 May 2014 18:35:02 +0200

=== debian/control ===
Source: sfront
Section: sound
Priority: optional
Maintainer: Santiago Vila <sanvila@debian.org>
Build-Depends: debhelper-compat (= 13), bison
Standards-Version: 4.7.0
Vcs-Git: https://salsa.debian.org/sanvila/sfront.git
Vcs-Browser: https://salsa.debian.org/sanvila/sfront
Homepage: https://john-lazzaro.github.io/sa/

Package: sfront
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: make, gcc | c-compiler
Description: MPEG 4 Structured Audio decoder
 Sfront compiles MPEG 4 Structured Audio (MP4-SA) bitstreams into
 efficient C programs that generate audio when executed. It supports
 real-time, low-latency audio input/output, MIDI input from
 soundcards, and Network Musical Performance.
 .
 MP4-SA is a standard for normative algorithmic sound, that combines
 an audio signal processing language (SAOL) with score languages
 (SASL, and the legacy MIDI File Format).
 .
 This package includes the sfront application, the sfront manual and
 "The MPEG-4 Structured Audio Book", a book on sound modeling and
 sequencing using MP4-SA.

=== debian/rules ===
#!/usr/bin/make -f
%:
	dh $@

override_dh_auto_build:
	cd src && $(MAKE) parser.tab.c
	cd src/lib && $(MAKE) CFLAGS="$(CFLAGS)" CPPFLAGS="$(CPPFLAGS)" \
		LINKLIB="$(LDFLAGS) -lm"
	cd src && $(MAKE) sfront CFLAGS="$(CFLAGS)" CPPFLAGS="$(CPPFLAGS)" \
		LINKLIB="$(LDFLAGS) -lm"

override_dh_auto_clean:
	rm -f build src/lib/libmaker.o src/lib/libmaker
	cd src && $(MAKE) cleanall
	dh_auto_clean

override_dh_install:
	cd src && $(MAKE) install BINDIR=../debian/sfront/usr/bin
	cp -a lib/* debian/sfront/usr/share/sfront
	cp -a README.HTML index.html sfman book copyright \
		debian/sfront/usr/share/doc/sfront/html
	find debian/sfront -name "._*" | xargs rm -f

override_dh_installexamples:
	dh_installexamples -Xrtime/au examples/*

override_dh_installchangelogs:
	dh_installchangelogs --no-trim

override_dh_installman:
	dh_installman debian/sfront.1

override_dh_compress:
# Do not compress files referenced in the HTML manual or in example makefiles.
	dh_compress -XASYS -Xpsync.c -X.c -X.saol -X.sasl -X.wav -XFDL
